Subject: Re: [PATCH 1/2 net v4] ipv6: addrconf: fix temp address generation after prefix deprecation

From: Ido Schimmel <[email-masked]>
Date: Wed, 13 May 2026 10:17:22 +0300

On Tue, May 12, 2026 at 05:01:17PM -0700, Jakub Kicinski wrote:
> On Mon, 11 May 2026 14:26:45 +0200 Fernando Fernandez Mancera wrote:
> > When a router temporarily deprecates an IPv6 prefix (either by sending a
> > Router Advertisement with Preferred Lifetime = 0 or by letting the
> > lifetime expire) and later restores it, the kernel permanently loses its
> > ability to generate temporary privacy addresses (RFC 8981) for that
> > prefix.
> > 
> > This happens because the address worker attempts to generate a
> > replacement temporary address when the current one nears expiration. As
> > the base prefix is deprecated already, the generation fails after
> > marking the temporary address as already having spawned a replacement
> > (ifp->regen_count++).
> > 
> > When the router eventually restores the prefix, the temporary address
> > becomes active again. However, once it naturally expires, the address
> > worker sees this temporary address already tried to generate one and
> > skips the regeneration.
> > 
> > Fix this by checking if all temporary addresses for a given prefix have
> > already tried to spawn a replacement when processing a new RA. If so,
> > spawn a new temporary address.
> > 
> > Fixes: 1da177e4c3f4 ("Linux-2.6.12-rc2")
> 
> No feedback on the patch itself, but I wanted to check - Ido, do you
> think this is worth handling as a fix? Sounds like this scenario never
> worked.

No, I think we should target net-next. The scenario never worked and the
fix has the potential to cause other issues.

Fernando, please wait with the next version. I need some time to go over
the Sashiko feedback.